// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "Rubrikator.h"
#include "DlgProxy.h"
#include "RubrikatorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRubrikatorDlgAutoProxy

IMPLEMENT_DYNCREATE(CRubrikatorDlgAutoProxy, CCmdTarget)

CRubrikatorDlgAutoProxy::CRubrikatorDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CRubrikatorDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CRubrikatorDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CRubrikatorDlgAutoProxy::~CRubrikatorDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CRubrikatorDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CRubrikatorDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CRubrikatorDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CRubrikatorDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CRubrikatorDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IRubrikator to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {3F18107B-9D76-4DF5-A724-A17EAB4AD8E3}
static const IID IID_IRubrikator =
{ 0x3f18107b, 0x9d76, 0x4df5, { 0xa7, 0x24, 0xa1, 0x7e, 0xab, 0x4a, 0xd8, 0xe3 } };

BEGIN_INTERFACE_MAP(CRubrikatorDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CRubrikatorDlgAutoProxy, IID_IRubrikator, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {503184CB-0796-459D-BFE3-A9BD842F78C4}
IMPLEMENT_OLECREATE2(CRubrikatorDlgAutoProxy, "Rubrikator.Application", 0x503184cb, 0x796, 0x459d, 0xbf, 0xe3, 0xa9, 0xbd, 0x84, 0x2f, 0x78, 0xc4)

/////////////////////////////////////////////////////////////////////////////
// CRubrikatorDlgAutoProxy message handlers
